class Money
	attr_reader :currency, :amount
	#initialize the amount and currency
	def initialize(amount, currency)
		@amount = amount.to_i
		@currency = currency
	end

	#print the amount
	def amount
		amount/1.0
	end

	#print the amount and currency
	def inspect
		"#{amount} and #{currency}"
	end

	#this will convert the currency using the changed_curr method
	def convert_to(newcurr)
		Money.new(changed_curr(newcurr),newcurr)
	end

	#This calles the conversation rate that was given to use and multiplies the amount by that much
	def changed_curr(newcurr)
		multiplier = Money.conversion_rate(from: currency, to: newcurr)
		amount * multiplier
	end

	#This will take the given converstion rate data and save it using the conversation_rate method
	def conversion_rates(currency, conv_rates = nil)
		saved_data[currency] = conv_rates
	end
	
	def conversion_rate(from:,to:)
		saved_data[from][to] || puts "Didn't convert correctly"
	end

	def +(x)
		is_curr_same(x) { |x,y| Money.new(x + y, currency)}
	end

	def -(x)
		is_curr_same(x) { |x,y| Money.new(x - y, currency)}
	end

	def *(x)
		Money.new(amount * x, currency)
	end

	def /(x)
		Money.new(amount / x, currency)
	end

	def ==(x)
		true if currency == x.currency
		false if currency != x.currency
	end
	def >(x)
		true if currency > x.currency
		false
	end
	def <(x)
		true if currency < x.currency
		false
	end


	private
	def is_curr_same(temp)
		if currency == temp.currency
			yield amount, temp.amount
		else
			change = temp.convert_to(currency)
			yield amount, change.amount
		end
	end

	end


	def saved_data
		@conv_rates || @conv_rates = {}
	end

end
